// Copyright 2018 The Flutter team. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

import 'package:flutter_apm/apm_module.dart';

class CashCallCode {
  //Counter of transaction, reset every day
  int nbTransactionDay = 0;

  //Counter of transaction, reset every week
  int nbTransactionWeek = 0;

  //Counter of transaction, reset every month
  int nbTransactionMonth = 0;

  //Amount of transactions, reset every day
  double amountTransactionDay = 0;

  //Amount of transactions, reset every week
  double amountTransactionWeek = 0;

  //Amount of transactions, reset every month
  double amountTransactionMonth = 0;

  void makeTransaction(double amount, String billType) {
    //****************************************************************************//

    APMModule.triggerAction("first_transaction");

    Map properties = new Map();
    properties["amount"] = ""+amount.toString(); //amount cast to string
    properties["bill_type"] = ""+billType; //???
    APMModule.triggerActionWithProperties("transaction", properties);

    //****************************************************************************//
    //number_transaction_day
    //number_transaction_week
    //number_transaction_month

    //Per day
    nbTransactionDay++;
    if(nbTransactionDay < 10) { //10 transactions (TO BE DEFINE)
      APMModule.triggerAction("number_transaction_day"); //+10 points
      nbTransactionDay = 0;
    }

    //Per week
    nbTransactionWeek++;
    if(nbTransactionWeek < 20) { //20 transactions (TO BE DEFINE)
      APMModule.triggerAction("number_transaction_week"); //+20 points
      nbTransactionWeek = 0;
    }

    //Per month
    nbTransactionMonth++;
    if(nbTransactionMonth < 30) { //30 transactions (TO BE DEFINE)
      APMModule.triggerAction("number_transaction_month"); //+30 points
      nbTransactionMonth = 0;
    }

    //****************************************************************************//
    //revenue_transaction_day
    //revenue_transaction_week
    //revenue_transaction_month

    //Per day
    amountTransactionDay = amountTransactionDay + amount;
    if(amountTransactionDay < 30) { //30 EGP (TO BE DEFINE)
      APMModule.triggerAction("revenue_transaction_day"); //+10 points
      amountTransactionDay = 0;
    }

    //Per week
    amountTransactionWeek = amountTransactionWeek + amount;
    if(amountTransactionWeek < 50) { //50 EGP (TO BE DEFINE)
      APMModule.triggerAction("revenue_transaction_week"); //+20 points
      amountTransactionWeek = 0;
    }

    //Per month
    amountTransactionMonth = amountTransactionMonth + amount;
    if(amountTransactionMonth < 100) { //100 EGP (TO BE DEFINE)
      APMModule.triggerAction("revenue_transaction_month"); //+30 points
      amountTransactionMonth = 0;
    }
  }

  //Counter of transaction, reset every day
  int nbReload = 0;

  void reload(double amount) {
    if(nbReload == 0) {
      APMModule.triggerAction("first_reload");
      nbReload = 1;
    }
    else if(nbReload == 1) {
      APMModule.triggerAction("second_reload");
    }

    Map properties = new Map();
    properties["amount"] = ""+amount.toString(); //amount cast to string
    APMModule.triggerActionWithProperties("reload", properties);
  }
}
